hit-0.6.3: Git operations in haskell

License | BSD-style
Maintainer | Vincent Hanquez <vincent@snarc.org>
Stability | experimental
Portability | unix
Safe Haskell | Safe
Language | Haskell98

Data.Git.Revision

Description

Synopsis

- data Revision = Revision String [RevModifier]
- data RevModifier
  - = RevModParent Int
  - | RevModParentFirstN Int
  - | RevModAtType String
  - | RevModAtDate String
  - | RevModAtN Int
- data RevisionNotFound = RevisionNotFound Revision
- fromString :: IsString a => String -> a

# Documentation

data Revision Source #

A git revision. this can be many things: * a shorten ref * a ref * a named branch or tag followed by optional modifiers `RevModifier` that can represent: * parenting * type * date

Constructors

Revision String [RevModifier] |

Instances

Eq Revision Source # |
Methods (==) :: Revision -> Revision -> Bool # (/=) :: Revision -> Revision -> Bool #
Data Revision Source # |

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Revision -> c Revision #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Revision #

toConstr :: Revision -> Constr #

dataTypeOf :: Revision -> DataType #

dataCast1 :: Typeable (* -> *) t => (forall d. Data d => c (t d)) -> Maybe (c Revision) #

dataCast2 :: Typeable (* -> * -> *) t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Revision) #

gmapT :: (forall b. Data b => b -> b) -> Revision -> Revision #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Revision -> r #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Revision -> r #

gmapQ :: (forall d. Data d => d -> u) -> Revision -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Revision -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Revision -> m Revision #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Revision -> m Revision #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Revision -> m Revision #

Show Revision Source # |
Methods showsPrec :: Int -> Revision -> ShowS # show :: Revision -> String # showList :: [Revision] -> ShowS #
IsString Revision Source # |
Methods fromString :: String -> Revision #

data RevModifier Source #

A modifier to a revision, which is a function apply of a revision

Constructors

RevModParent Int | parent accessor ^n and ^
RevModParentFirstN Int | parent accessor ~n
RevModAtType String | @{type} accessor
RevModAtDate String | @{date} accessor
RevModAtN Int | @{n} accessor

Instances

Eq RevModifier Source # |
Methods (==) :: RevModifier -> RevModifier -> Bool # (/=) :: RevModifier -> RevModifier -> Bool #
Data RevModifier Source # |

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> RevModifier -> c RevModifier #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c RevModifier #

toConstr :: RevModifier -> Constr #

dataTypeOf :: RevModifier -> DataType #

dataCast1 :: Typeable (* -> *) t => (forall d. Data d => c (t d)) -> Maybe (c RevModifier) #

dataCast2 :: Typeable (* -> * -> *) t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c RevModifier) #

gmapT :: (forall b. Data b => b -> b) -> RevModifier -> RevModifier #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> RevModifier -> r #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> RevModifier -> r #

gmapQ :: (forall d. Data d => d -> u) -> RevModifier -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> RevModifier -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> RevModifier -> m RevModifier #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> RevModifier -> m RevModifier #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> RevModifier -> m RevModifier #

Show RevModifier Source # |
Methods showsPrec :: Int -> RevModifier -> ShowS # show :: RevModifier -> String # showList :: [RevModifier] -> ShowS #

data RevisionNotFound Source #

Exception when a revision cannot be resolved to a reference

Constructors

RevisionNotFound Revision |

Instances

Eq RevisionNotFound Source # |
Methods (==) :: RevisionNotFound -> RevisionNotFound -> Bool # (/=) :: RevisionNotFound -> RevisionNotFound -> Bool #
Data RevisionNotFound Source # |

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> RevisionNotFound -> c RevisionNotFound #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c RevisionNotFound #

toConstr :: RevisionNotFound -> Constr #

dataTypeOf :: RevisionNotFound -> DataType #

dataCast1 :: Typeable (* -> *) t => (forall d. Data d => c (t d)) -> Maybe (c RevisionNotFound) #

dataCast2 :: Typeable (* -> * -> *) t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c RevisionNotFound) #

gmapT :: (forall b. Data b => b -> b) -> RevisionNotFound -> RevisionNotFound #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> RevisionNotFound -> r #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> RevisionNotFound -> r #

gmapQ :: (forall d. Data d => d -> u) -> RevisionNotFound -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> RevisionNotFound -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> RevisionNotFound -> m RevisionNotFound #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> RevisionNotFound -> m RevisionNotFound #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> RevisionNotFound -> m RevisionNotFound #

Show RevisionNotFound Source # |
Methods showsPrec :: Int -> RevisionNotFound -> ShowS # show :: RevisionNotFound -> String # showList :: [RevisionNotFound] -> ShowS #

fromString :: IsString a => String -> a #